Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Import.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Import.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Import.pm	(revision 34921)
@@ -13,5 +13,5 @@
 use vars qw($VERSION @ISA @EXPORT_OK);
 
-$VERSION = '1.00';
+$VERSION = '1.10';
 @ISA = qw(Exporter);
 @EXPORT_OK = qw(ReadCSV ReadJSON);
@@ -19,22 +19,33 @@
 sub ReadJSONObject($;$);
 
-my %unescapeJSON = ( 't'=>"\t", 'n'=>"\n", 'r'=>"\r" );
+my %unescapeJSON = ( 't'=>"\t", 'n'=>"\n", 'r'=>"\r", 'b' => "\b", 'f' => "\f" );
 my $charset;
 
 #------------------------------------------------------------------------------
 # Read CSV file
-# Inputs: 0) CSV file name, 1) database hash ref, 2) flag to delete "-" tags
+# Inputs: 0) CSV file name, file ref or RAF ref, 1) database hash ref,
+#         2) missing tag value, 3) delimiter if other than ','
 # Returns: undef on success, or error string
 # Notes: There are various flavours of CSV, but here we assume that only
 #        double quotes are escaped, and they are escaped by doubling them
-sub ReadCSV($$;$)
+sub ReadCSV($$;$$)
 {
     local ($_, $/);
-    my ($file, $database, $delDash) = @_;
-    my ($buff, @tags, $found, $err);
-
-    open CSVFILE, $file or return "Error opening CSV file '$file'";
-    binmode CSVFILE;
-    my $raf = new File::RandomAccess(\*CSVFILE);
+    my ($file, $database, $missingValue, $delim) = @_;
+    my ($buff, @tags, $found, $err, $raf, $openedFile);
+
+    if (UNIVERSAL::isa($file, 'File::RandomAccess')) {
+        $raf = $file;
+        $file = 'CSV file';
+    } elsif (ref $file eq 'GLOB') {
+        $raf = new File::RandomAccess($file);
+        $file = 'CSV file';
+    } else {
+        open CSVFILE, $file or return "Error opening CSV file '${file}'";
+        binmode CSVFILE;
+        $openedFile = 1;
+        $raf = new File::RandomAccess(\*CSVFILE);
+    }
+    $delim = ',' unless defined $delim;
     # set input record separator by first newline found in the file
     # (safe because first line should contain only tag names)
@@ -45,5 +56,5 @@
     while ($raf->ReadLine($buff)) {
         my (@vals, $v, $i, %fileInfo);
-        my @toks = split ',', $buff;
+        my @toks = split /\Q$delim/, $buff;
         while (@toks) {
             ($v = shift @toks) =~ s/^ +//;  # remove leading spaces
@@ -52,9 +63,9 @@
                 while ($v !~ /("+)\s*$/ or not length($1) & 1) {
                     if (@toks) {
-                        $v .= ',' . shift @toks;
+                        $v .= $delim . shift @toks;
                     } else {
                         # read another line from the file
                         $raf->ReadLine($buff) or last;
-                        @toks = split ',', $buff;
+                        @toks = split /\Q$delim/, $buff;
                         last unless @toks;
                         $v .= shift @toks;
@@ -71,7 +82,9 @@
             # save values for each tag
             for ($i=0; $i<@vals and $i<@tags; ++$i) {
-                next unless length $vals[$i];   # ignore empty entries
-                # delete tag if value (set value to undef) is '-' and -f option is used
-                $fileInfo{$tags[$i]} = ($vals[$i] eq '-' and $delDash) ? undef : $vals[$i];
+                # ignore empty entries unless missingValue is empty too
+                next unless length $vals[$i] or defined $missingValue and $missingValue eq '';
+                # delete tag (set value to undef) if value is same as missing tag
+                $fileInfo{$tags[$i]} =
+                    (defined $missingValue and $vals[$i] eq $missingValue) ? undef : $vals[$i];
             }
             # figure out the file name to use
@@ -83,12 +96,17 @@
             # the first row should be the tag names
             foreach (@vals) {
-                /^[-\w]+(:[-\w+]+)?#?$/ or $err = "Invalid tag name '$_'", last;
+                # terminate at first blank tag name (eg. extra comma at end of line)
+                last unless length $_;
+                @tags or s/^\xef\xbb\xbf//; # remove UTF-8 BOM if it exists
+                /^[-\w]+(:[-\w+]+)?#?$/ or $err = "Invalid tag name '${_}'", last;
                 push(@tags, $_);
             }
             last if $err;
             @tags or $err = 'No tags found', last;
-        }
-    }
-    close CSVFILE;
+            # fix "SourceFile" case if necessary
+            $tags[0] = 'SourceFile' if lc $tags[0] eq 'sourcefile';
+        }
+    }
+    close CSVFILE if $openedFile;
     undef $raf;
     $err = 'No SourceFile column' unless $found or $err;
@@ -108,5 +126,6 @@
 #------------------------------------------------------------------------------
 # Read JSON object from file
-# Inputs: 0) JSON file handle, 1) optional file buffer reference
+# Inputs: 0) RAF reference or undef, 1) optional scalar reference for data
+#            to read before reading from file (ie. the file read buffer)
 # Returns: JSON object (scalar, hash ref, or array ref), or undef on EOF or
 #          empty object or array (and sets $$buffPt to empty string on EOF)
@@ -114,9 +133,10 @@
 sub ReadJSONObject($;$)
 {
-    my ($fp, $buffPt) = @_;
+    my ($raf, $buffPt) = @_;
     # initialize buffer if necessary
-    my ($pos, $readMore, $rtnVal, $tok, $key);
+    my ($pos, $readMore, $rtnVal, $tok, $key, $didBOM);
     if ($buffPt) {
         $pos = pos $$buffPt;
+        $pos = pos($$buffPt) = 0 unless defined $pos;
     } else {
         my $buff = '';
@@ -125,9 +145,22 @@
     }
 Tok: for (;;) {
+        # (didn't spend the time to understand how $pos could be undef, but
+        #  put a test here to be safe because one user reported this problem)
+        last unless defined $pos;
         if ($pos >= length $$buffPt or $readMore) {
+            last unless defined $raf;
             # read another 64kB and add to unparsed data
             my $offset = length($$buffPt) - $pos;
-            $$buffPt = substr($$buffPt, $pos) if $offset;
-            read $fp, $$buffPt, 65536, $offset or $$buffPt = '', last;
+            if ($offset) {
+                my $buff;
+                $raf->Read($buff, 65536) or $$buffPt = '', last;
+                $$buffPt = substr($$buffPt, $pos) . $buff;
+            } else {
+                $raf->Read($$buffPt, 65536) or $$buffPt = '', last;
+            }
+            unless ($didBOM) {
+                $$buffPt =~ s/^\xef\xbb\xbf//;  # remove UTF-8 BOM if it exists
+                $didBOM = 1;
+            }
             $pos = pos($$buffPt) = 0;
             $readMore = 0;
@@ -145,5 +178,5 @@
                 # read "KEY":"VALUE" pairs
                 unless (defined $key) {
-                    $key = ReadJSONObject($fp, $buffPt);
+                    $key = ReadJSONObject($raf, $buffPt);
                     $pos = pos $$buffPt;
                 }
@@ -153,5 +186,5 @@
                     $$buffPt =~ /(\S)/g or $readMore = 1, next Tok;
                     $1 eq ':' or return undef;  # error if not a colon
-                    my $val = ReadJSONObject($fp, $buffPt);
+                    my $val = ReadJSONObject($raf, $buffPt);
                     $pos = pos $$buffPt;
                     return undef unless defined $val;
@@ -167,5 +200,5 @@
             $rtnVal = [ ] unless defined $rtnVal;
             for (;;) {
-                my $item = ReadJSONObject($fp, $buffPt);
+                my $item = ReadJSONObject($raf, $buffPt);
                 $pos = pos $$buffPt;
                 # ($item may be undef for empty array)
@@ -185,4 +218,9 @@
             $rtnVal =~ s/\\u([0-9a-f]{4})/ToUTF8(hex $1)/ige;
             $rtnVal =~ s/\\(.)/$unescapeJSON{$1}||$1/sge;
+            # decode base64 (binary data) values
+            if ($rtnVal =~ /^base64:[A-Za-z0-9+\/]*={0,2}$/ and length($rtnVal) % 4 == 3) {
+                require Image::ExifTool::XMP;
+                $rtnVal = ${Image::ExifTool::XMP::DecodeBase64(substr($rtnVal,7))};
+            }
         } elsif ($tok eq ']' or $tok eq '}' or $tok eq ',') {
             # return undef for empty object, array, or list item
@@ -201,32 +239,53 @@
 #------------------------------------------------------------------------------
 # Read JSON file
-# Inputs: 0) JSON file name, 1) database hash ref, 2) flag to delete "-" tags
-#         2) character set
+# Inputs: 0) JSON file name, file ref or RAF ref, 1) database hash ref,
+#         2) flag to delete "-" tags, 3) character set
 # Returns: undef on success, or error string
 sub ReadJSON($$;$$)
 {
     local $_;
-    my ($file, $database, $delDash, $chset) = @_;
+    my ($file, $database, $missingValue, $chset) = @_;
+    my ($raf, $openedFile);
 
     # initialize character set for converting "\uHHHH" chars
     $charset = $chset || 'UTF8';
-    open JSONFILE, $file or return "Error opening JSON file '$file'";
-    binmode JSONFILE;
-    my $obj = ReadJSONObject(\*JSONFILE);
-    close JSONFILE;
+    if (UNIVERSAL::isa($file, 'File::RandomAccess')) {
+        $raf = $file;
+        $file = 'JSON file';
+    } elsif (ref $file eq 'GLOB') {
+        $raf = new File::RandomAccess($file);
+        $file = 'JSON file';
+    } else {
+        open JSONFILE, $file or return "Error opening JSON file '${file}'";
+        binmode JSONFILE;
+        $openedFile = 1;
+        $raf = new File::RandomAccess(\*JSONFILE);
+    }
+    my $obj = ReadJSONObject($raf);
+    close JSONFILE if $openedFile;
     unless (ref $obj eq 'ARRAY') {
-        ref $obj eq 'HASH' or return "Format error in JSON file '$file'";
+        ref $obj eq 'HASH' or return "Format error in JSON file '${file}'";
         $obj = [ $obj ];
     }
     my ($info, $found);
     foreach $info (@$obj) {
-        next unless ref $info eq 'HASH' and $$info{SourceFile};
-        if ($delDash) {
-            $$info{$_} eq '-' and $$info{$_} = undef foreach keys %$info;
+        next unless ref $info eq 'HASH';
+        # fix "SourceFile" case, or assume '*' if SourceFile not specified
+        unless (defined $$info{SourceFile}) {
+            my ($key) = grep /^SourceFile$/i, keys %$info;
+            if ($key) {
+                $$info{SourceFile} = $$info{$key};
+                delete $$info{$key};
+            } else {
+                $$info{SourceFile} = '*';
+            }
+        }
+        if (defined $missingValue) {
+            $$info{$_} eq $missingValue and $$info{$_} = undef foreach keys %$info;
         }
         $$database{$$info{SourceFile}} = $info;
         $found = 1;
     }
-    return $found ? undef : "No SourceFile entries in '$file'";
+    return $found ? undef : "No valid JSON objects in '${file}'";
 }
 
@@ -267,14 +326,15 @@
 =item Inputs:
 
-0) CSV file name.
+0) CSV file name or file reference.
 
 1) Hash reference for database object.
 
-2) Optional flag to set '-' values to undef in the database.  (Used for
-deleting tags.)
-
-3) [ReadJSON only] Optional character set for converting Unicode escape
-sequences in strings.  Defaults to "UTF8".  See the ExifTool Charset option
-for a list of valid settings.
+2) Optional string used to represent an undefined (missing) tag value. 
+(Used for deleting tags.)
+
+3) For ReadCSV this gives the delimiter for CSV entries, with a default of
+",".  For ReadJSON this is the character set for converting Unicode escape
+sequences in strings, with a default of "UTF8".  See the ExifTool Charset
+option for a list of valid character sets.
 
 =item Return Value:
@@ -289,5 +349,5 @@
 =head1 AUTHOR
 
-Copyright 2003-2011, Phil Harvey (phil at owl.phy.queensu.ca)
+Copyright 2003-2021, Phil Harvey (philharvey66 at gmail.com)
 
 This library is free software; you can redistribute it and/or modify it
Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/InDesign.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/InDesign.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/InDesign.pm	(revision 34921)
@@ -15,5 +15,5 @@
 use Image::ExifTool qw(:DataAccess :Utils);
 
-$VERSION = '1.02';
+$VERSION = '1.06';
 
 # map for writing metadata to InDesign files (currently only write XMP)
@@ -33,5 +33,5 @@
 sub ProcessIND($$)
 {
-    my ($exifTool, $dirInfo) = @_;
+    my ($et, $dirInfo) = @_;
     my $raf = $$dirInfo{RAF};
     my $outfile = $$dirInfo{OutFile};
@@ -42,5 +42,5 @@
     return 0 unless $hdr eq $masterPageGUID;
     return 0 unless $raf->Read($buff, 8) == 8;
-    $exifTool->SetFileType($buff eq 'DOCUMENT' ? 'INDD' : 'IND');   # set the FileType tag
+    $et->SetFileType($buff eq 'DOCUMENT' ? 'INDD' : 'IND');   # set the FileType tag
 
     # read the master pages
@@ -74,5 +74,5 @@
     $pages < 2 and $err = 'Invalid page count', goto DONE;
     my $pos = $pages * 4096;
-    if ($pos > 0x7fffffff and not $exifTool->Options('LargeFileSupport')) {
+    if ($pos > 0x7fffffff and not $et->Options('LargeFileSupport')) {
         $err = 'InDesign files larger than 2 GB not supported (LargeFileSupport not set)';
         goto DONE;
@@ -80,5 +80,5 @@
     if ($outfile) {
         # make XMP the preferred group for writing
-        $exifTool->InitWriteDirs(\%indMap, 'XMP');
+        $et->InitWriteDirs(\%indMap, 'XMP');
 
         Write($outfile, $buff, $buf2) or $err = 1, goto DONE;
@@ -93,6 +93,6 @@
     }
     # scan through the contiguous objects for XMP
-    my $verbose = $exifTool->Options('Verbose');
-    my $out = $exifTool->Options('TextOut');
+    my $verbose = $et->Options('Verbose');
+    my $out = $et->Options('TextOut');
     for (;;) {
         $raf->Read($hdr, 32) or last;
@@ -106,8 +106,7 @@
             printf $out "Contiguous object at offset 0x%x (%d bytes):\n", $raf->Tell(), $len;
             if ($verbose > 2) {
-                my %parms = (Addr => $raf->Tell());
-                $parms{MaxLen} = $verbose > 3 ? 1024 : 96 if $verbose < 5;
-                $raf->Seek(-$raf->Read($buff, $len), 1) or $err = 1;
-                Image::ExifTool::HexDump(\$buff, undef, %parms);
+                my $len2 = $len < 1024000 ? $len : 1024000;
+                $raf->Seek(-$raf->Read($buff, $len2), 1) or $err = 1;
+                $et->VerboseDump(\$buff, Addr => $raf->Tell());
             }
         }
@@ -119,4 +118,20 @@
                 my $lenWord = $1;   # save length word for writing later
                 $len -= 4;          # get length of XMP only
+                $foundXMP = 1;
+                # I have a sample where the XMP is 107 MB, and ActivePerl may run into
+                # memory troubles (with its apparent 1 GB limit) if the XMP is larger
+                # than about 400 MB, so guard against this
+                if ($len > 300 * 1024 * 1024) {
+                    my $msg = sprintf('Insanely large XMP (%.0f MB)', $len / (1024 * 1024));
+                    if ($outfile) {
+                        $et->Error($msg, 2) and $err = 1, last;
+                    } elsif ($et->Options('IgnoreMinorErrors')) {
+                        $et->Warn($msg);
+                    } else {
+                        $et->Warn("$msg. Ignored.", 1);
+                        $err = 1;
+                        last;
+                    }
+                }
                 # load and parse the XMP data
                 unless ($raf->Seek(-52, 1) and $raf->Read($buff, $len) == $len) {
@@ -124,5 +139,4 @@
                     last;
                 }
-                $foundXMP = 1;
                 my %dirInfo = (
                     DataPt  => \$buff,
@@ -130,16 +144,20 @@
                     NoDelete => 1, # do not allow this to be deleted when writing
                 );
+                # validate xmp data length (should be same as length in header - 4)
+                my $xmpLen = unpack($streamInt32u, $lenWord);
+                unless ($xmpLen == $len) {
+                    if ($xmpLen < $len) {
+                        $dirInfo{DirLen} = $xmpLen;
+                    } else {
+                        $err = 'Truncated XMP stream (missing ' . ($xmpLen - $len) . ' bytes)';
+                    }
+                }
                 my $tagTablePtr = GetTagTable('Image::ExifTool::XMP::Main');
                 if ($outfile) {
-                    # validate xmp data length (should be same as length in header - 4)
-                    my $xmpLen = unpack($streamInt32u, $lenWord);
-                    unless ($xmpLen == $len) {
-                        $err = "Incorrect XMP stream length ($xmpLen should be $len)";
-                        last;
-                    }
+                    last if $err;
                     # make sure that XMP is writable
                     my $classID = Get32u(\$hdr, 20);
                     $classID & 0x40000000 or $err = 'XMP stream is not writable', last;
-                    my $xmp = $exifTool->WriteDirectory(\%dirInfo, $tagTablePtr);
+                    my $xmp = $et->WriteDirectory(\%dirInfo, $tagTablePtr);
                     if ($xmp and length $xmp) {
                         # write new xmp with leading length word
@@ -149,11 +167,11 @@
                         Set32u(0xffffffff, \$hdr, 28);
                     } else {
-                        $$exifTool{CHANGED} = 0;    # didn't change anything
-                        $exifTool->Warn("Can't delete XMP as a block from InDesign file") if defined $xmp;
+                        $$et{CHANGED} = 0;    # didn't change anything
+                        $et->Warn("Can't delete XMP as a block from InDesign file") if defined $xmp;
                         # put length word back at start of stream
                         $buff = $lenWord . $buff;
                     }
                 } else {
-                    $exifTool->ProcessDirectory(\%dirInfo, $tagTablePtr);
+                    $et->ProcessDirectory(\%dirInfo, $tagTablePtr);
                 }
                 $len = 0;   # we got the full stream (nothing left to read)
@@ -198,12 +216,12 @@
 DONE:
     if (not $err) {
-        $exifTool->Warn('No XMP stream to edit') if $outfile and not $foundXMP;
+        $et->Warn('No XMP stream to edit') if $outfile and not $foundXMP;
         return 1;       # success!
     } elsif (not $outfile) {
         # issue warning on read error
-        $exifTool->Warn($err) unless $err eq '1';
+        $et->Warn($err) unless $err eq '1';
     } elsif ($err ne '1') {
         # set error and return success code
-        $exifTool->Error($err);
+        $et->Error($err);
     } else {
         return -1;      # write error
@@ -236,10 +254,10 @@
 InDesign files which previously contained XMP.
 
-3) File sizes of greater than 2 GB and are not currently supported because
-the ability to handle large files like this is system dependent.
+3) File sizes of greater than 2 GB are supported only if the system supports
+them and the LargeFileSupport option is enabled.
 
 =head1 AUTHOR
 
-Copyright 2003-2011, Phil Harvey (phil at owl.phy.queensu.ca)
+Copyright 2003-2021, Phil Harvey (philharvey66 at gmail.com)
 
 This library is free software; you can redistribute it and/or modify it
